> ## Documentation Index
> Fetch the complete documentation index at: https://docs.costory.io/llms.txt
> Use this file to discover all available pages before exploring further.

# Create a billing datasource



## OpenAPI

````yaml /api-reference/openapi.json post /terraform/billingDatasources
openapi: 3.0.0
info:
  title: Costory
  version: '1.0'
  description: API Documentation
servers:
  - url: https://app-api.costory.io
security: []
paths:
  /terraform/billingDatasources:
    post:
      tags:
        - Admin Billing Datasources
      summary: Create a billing datasource
      requestBody:
        content:
          application/json:
            schema:
              $ref: '#/components/schemas/AdminBillingDatasourceCreate'
      responses:
        '201':
          description: Billing datasource created
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/AdminCreateBillingDatasourceResponse'
        '400':
          description: Bad request
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/BadRequest'
        '401':
          description: Unauthorized
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/Unauthorized'
        '403':
          description: Forbidden
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/BadRequest'
        '404':
          description: Not found
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/NotFound'
      security:
        - bearerAuth: []
        - apiKeyAuth: []
components:
  schemas:
    AdminBillingDatasourceCreate:
      oneOf:
        - type: object
          properties:
            name:
              type: string
            type:
              type: string
              enum:
                - GCP
            bqTablePath:
              type: string
            isDetailedBilling:
              type: boolean
            startDate:
              type: string
              nullable: true
              format: date-time
            endDate:
              type: string
              nullable: true
              format: date-time
          required:
            - name
            - type
            - bqTablePath
        - type: object
          properties:
            name:
              type: string
            type:
              type: string
              enum:
                - Azure
            sasUrl:
              type: string
              format: uri
            containerName:
              type: string
              minLength: 1
            storageAccountName:
              type: string
              minLength: 1
            actualsPath:
              type: string
              minLength: 1
            amortizedPath:
              type: string
              minLength: 1
          required:
            - name
            - type
            - sasUrl
            - containerName
            - storageAccountName
            - actualsPath
            - amortizedPath
        - type: object
          properties:
            name:
              type: string
            type:
              type: string
              enum:
                - AWS
            bucketName:
              type: string
            roleArn:
              type: string
              pattern: ^arn:aws:iam::\d{12}:role\/[\w+=,.@-]+$
            prefix:
              type: string
              default: ''
            eksSplitDataEnabled:
              type: boolean
              default: false
            startDate:
              type: string
              nullable: true
              format: date-time
            endDate:
              type: string
              nullable: true
              format: date-time
            eksSplit:
              type: boolean
          required:
            - name
            - type
            - bucketName
            - roleArn
        - type: object
          properties:
            name:
              type: string
            type:
              type: string
              enum:
                - Cursor
            adminApiKey:
              type: string
              minLength: 1
            startDate:
              type: string
              nullable: true
              format: date-time
            endDate:
              type: string
              nullable: true
              format: date-time
          required:
            - name
            - type
            - adminApiKey
        - type: object
          properties:
            name:
              type: string
            type:
              type: string
              enum:
                - Anthropic
            adminApiKey:
              type: string
              minLength: 1
            startDate:
              type: string
              nullable: true
              format: date-time
            endDate:
              type: string
              nullable: true
              format: date-time
          required:
            - name
            - type
            - adminApiKey
        - type: object
          properties:
            name:
              type: string
            type:
              type: string
              enum:
                - ElasticCloud
            apiKey:
              type: string
              minLength: 1
            organizationId:
              type: string
              minLength: 1
            startDate:
              type: string
              nullable: true
              format: date-time
          required:
            - name
            - type
            - apiKey
            - organizationId
        - type: object
          properties:
            name:
              type: string
            type:
              type: string
              enum:
                - ClickHouseCloud
            keyId:
              type: string
              minLength: 1
            keySecret:
              type: string
              minLength: 1
            organizationId:
              type: string
              minLength: 1
            startDate:
              type: string
              nullable: true
              format: date-time
          required:
            - name
            - type
            - keyId
            - keySecret
            - organizationId
      discriminator:
        propertyName: type
    AdminCreateBillingDatasourceResponse:
      allOf:
        - oneOf:
            - type: object
              properties:
                name:
                  type: string
                type:
                  type: string
                  enum:
                    - GCP
                bqUri:
                  type: string
                startDate:
                  type: string
                  nullable: true
                  format: date-time
                endDate:
                  type: string
                  nullable: true
                  format: date-time
                isDetailedBilling:
                  type: boolean
                status:
                  type: string
              required:
                - name
                - type
                - bqUri
            - type: object
              properties:
                name:
                  type: string
                type:
                  type: string
                  enum:
                    - Azure
                storageAccountName:
                  type: string
                containerName:
                  type: string
                actualsPath:
                  type: string
                amortizedPath:
                  type: string
                status:
                  type: string
              required:
                - name
                - type
                - storageAccountName
                - containerName
                - actualsPath
            - type: object
              properties:
                name:
                  type: string
                type:
                  type: string
                  enum:
                    - AWS
                bucketName:
                  type: string
                roleArn:
                  type: string
                prefix:
                  type: string
                eksSplitDataEnabled:
                  type: boolean
                  default: false
                startDate:
                  type: string
                  nullable: true
                  format: date-time
                endDate:
                  type: string
                  nullable: true
                  format: date-time
                eksSplit:
                  type: boolean
                status:
                  type: string
              required:
                - name
                - type
                - bucketName
                - roleArn
                - prefix
            - type: object
              properties:
                name:
                  type: string
                type:
                  type: string
                  enum:
                    - Cursor
                bqTableUri:
                  type: string
                startDate:
                  type: string
                  nullable: true
                  format: date-time
                endDate:
                  type: string
                  nullable: true
                  format: date-time
                status:
                  type: string
              required:
                - name
                - type
                - bqTableUri
            - type: object
              properties:
                name:
                  type: string
                type:
                  type: string
                  enum:
                    - Anthropic
                bqTableUri:
                  type: string
                startDate:
                  type: string
                  nullable: true
                  format: date-time
                endDate:
                  type: string
                  nullable: true
                  format: date-time
                status:
                  type: string
              required:
                - name
                - type
                - bqTableUri
            - type: object
              properties:
                name:
                  type: string
                type:
                  type: string
                  enum:
                    - ElasticCloud
                bqTableUri:
                  type: string
                startDate:
                  type: string
                  nullable: true
                  format: date-time
                status:
                  type: string
              required:
                - name
                - type
                - bqTableUri
            - type: object
              properties:
                name:
                  type: string
                type:
                  type: string
                  enum:
                    - ClickHouseCloud
                bqTableUri:
                  type: string
                startDate:
                  type: string
                  nullable: true
                  format: date-time
                status:
                  type: string
              required:
                - name
                - type
                - bqTableUri
          discriminator:
            propertyName: type
        - type: object
          properties:
            id:
              type: string
          required:
            - id
    BadRequest:
      type: object
      properties:
        error:
          type: string
          description: Error code
        reason:
          type: string
          description: Human-readable reason
        details:
          description: Additional details
        summary:
          type: string
          description: Optional short summary
      required:
        - error
    Unauthorized:
      type: object
      properties:
        error:
          type: string
          description: Unauthorized error message
      required:
        - error
    NotFound:
      type: object
      properties:
        error:
          type: string
          description: Resource not found error code
      required:
        - error
  securitySchemes:
    bearerAuth:
      type: http
      scheme: bearer
      bearerFormat: JWT or Clerk ak_* API key
      description: >-
        Send `Authorization: Bearer <credential>` using either a Clerk session
        JWT or a Clerk API key (`ak_*`). API keys may identify a user (`user_*`)
        or organization (`org_*`) principal and are generated in the Clerk
        Dashboard under API keys.
    apiKeyAuth:
      type: apiKey
      in: header
      name: x-api-token
      description: >-
        API token for authentication (or Admin API key). The token is scoped per
        organization and can be retrieved in the Organization Switcher.

````